Bullet Collision Detection & Physics Library: btPolyhedralConvexAabbCachingShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
btPolyhedralConvexAabbCachingShape Class Reference

The btPolyhedralConvexAabbCachingShape adds aabb caching to the btPolyhedralConvexShape. More...

`#include <btPolyhedralConvexShape.h>`

Inheritance diagram for btPolyhedralConvexAabbCachingShape:
[legend]
Collaboration diagram for btPolyhedralConvexAabbCachingShape:
[legend]

## Public Member Functions
void | getNonvirtualAabb (const btTransform &trans, btVector3 &aabbMin, btVector3 &aabbMax, btScalar margin) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
void | recalcLocalAabb ()
Public Member Functions inherited from btPolyhedralConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btPolyhedralConvexShape ()
virtual | ~btPolyhedralConvexShape ()
virtual bool | initializePolyhedralFeatures (int shiftVerticesByMargin=0)
| optional method mainly used to generate multiple contact points by clipping polyhedral features (faces/edges) experimental/work-in-progress
virtual void | setPolyhedralFeatures (btConvexPolyhedron &polyhedron)
const btConvexPolyhedron * | getConvexPolyhedron () const
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
virtual int | getNumVertices () const =0
virtual int | getNumEdges () const =0
virtual void | getEdge (int i, btVector3 &pa, btVector3 &pb) const =0
virtual void | getVertex (int i, btVector3 &vtx) const =0
virtual int | getNumPlanes () const =0
virtual void | getPlane (btVector3 &planeNormal, btVector3 &planeSupport, int i) const =0
virtual bool | isInside (const btVector3 &pt, btScalar tolerance) const =0
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs'
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Protected Member Functions
void | setCachedLocalAabb (const btVector3 &aabbMin, const btVector3 &aabbMax)
void | getCachedLocalAabb (btVector3 &aabbMin, btVector3 &aabbMax) const
| btPolyhedralConvexAabbCachingShape ()
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()

## Private Attributes
btVector3 | m_localAabbMin
btVector3 | m_localAabbMax
bool | m_isLocalAabbValid

## Additional Inherited Members
Protected Attributes inherited from btPolyhedralConvexShape
btConvexPolyhedron * | m_polyhedron
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btPolyhedralConvexAabbCachingShape adds aabb caching to the btPolyhedralConvexShape.

Definition at line 67 of file btPolyhedralConvexShape.h.

## Constructor & Destructor Documentation

## ◆ btPolyhedralConvexAabbCachingShape()

btPolyhedralConvexAabbCachingShape::btPolyhedralConvexAabbCachingShape | ( |  | ) |
| protected

Definition at line 492 of file btPolyhedralConvexShape.cpp.

## Member Function Documentation

## ◆ getAabb()

void btPolyhedralConvexAabbCachingShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax ) const
| virtual

getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version

Reimplemented from btConvexInternalShape.

Reimplemented in btBU_Simplex1to4.

Definition at line 500 of file btPolyhedralConvexShape.cpp.

## ◆ getCachedLocalAabb()

void btPolyhedralConvexAabbCachingShape::getCachedLocalAabb | ( | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax ) const
| inlineprotected

Definition at line 81 of file btPolyhedralConvexShape.h.

## ◆ getNonvirtualAabb()

void btPolyhedralConvexAabbCachingShape::getNonvirtualAabb | ( | const btTransform & | trans,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax,
|  | btScalar | margin ) const
| inline

Definition at line 92 of file btPolyhedralConvexShape.h.

## ◆ recalcLocalAabb()

void btPolyhedralConvexAabbCachingShape::recalcLocalAabb | ( |  | ) |

Definition at line 505 of file btPolyhedralConvexShape.cpp.

## ◆ setCachedLocalAabb()

void btPolyhedralConvexAabbCachingShape::setCachedLocalAabb | ( | const btVector3 & | aabbMin,
|  | const btVector3 & | aabbMax )
| inlineprotected

Definition at line 74 of file btPolyhedralConvexShape.h.

## ◆ setLocalScaling()

void btPolyhedralConvexAabbCachingShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Reimplemented from btConvexInternalShape.

Reimplemented in btConvexHullShape, btConvexPointCloudShape, and btConvexTriangleMeshShape.

Definition at line 486 of file btPolyhedralConvexShape.cpp.

## Member Data Documentation

## ◆ m_isLocalAabbValid

bool btPolyhedralConvexAabbCachingShape::m_isLocalAabbValid
| private

Definition at line 71 of file btPolyhedralConvexShape.h.

## ◆ m_localAabbMax

btVector3 btPolyhedralConvexAabbCachingShape::m_localAabbMax
| private

Definition at line 70 of file btPolyhedralConvexShape.h.

## ◆ m_localAabbMin

btVector3 btPolyhedralConvexAabbCachingShape::m_localAabbMin
| private

Definition at line 69 of file btPolyhedralConvexShape.h.

The documentation for this class was generated from the following files:

- btPolyhedralConvexShape.h
- btPolyhedralConvexShape.cpp